#include "gfx.h"

/*

  ********************************************************************

          Postscript specific drawing routines follow

          device = 3  (encap = 1 for encapsulated ps)

  ********************************************************************

  last mods:
        11/25/94 added sup/sub etc to ps_text
                added font procs to ps_initg
                fixed %%document comment
                added ps_strlen and ps_fix_text
                added ps_escape_text
        12/09/95 added line width 36 (index 5)
        
        5/27/97 added psbb call and Creationdate comment
        
        5/31/97 commented out timeout settings
        	added labeling of non encap plots
*/

ps_abort ()
{
/*
14107 REM
14108 REM  ABORT PLOT    .... really only matters for direct printing
14109 REM
*/

if( encap == 0)
{
 strcpy(pout," erasepage initgraphics statusdict begin /waittimeout 30 def end ");
 plot_out(pout);
}
}

ps_initg ()
{
/*
REM     INIT PLOTTER for postscript
*/
float tllx,turx,tlly,tury,t;
char pp[]="%%";  /* to sprintf %% */
char now[50];

     strcpy(pout,"%!PS-Adobe-2.0 EPSF-2.0");
     plot_out(pout); /* postscript start flag */
     
     psbb(&tllx,&tlly,&turx,&tury); /* get bb dimensions */
     
     sprintf(pout,"%sBoundingBox: %i %i %i %i ",pp,(int)(72 * tllx),(int)(72 * tlly),(int)(72 * turx),(int)(72 * tury));
     plot_out(pout);
     sprintf(pout,"%sTitle: %s",pp, filecurrent);
     plot_out(pout);
     sprintf(pout,"%sCreator: %s",pp,PROGNAME);
     plot_out(pout);
     
     strcpy(pout,"%%CreationDate: ");
     time_and_date(now);
     strcat(pout,now);
     plot_out(pout);

     strcpy(pout,"%%EndComments");
     plot_out(pout);

     if(encap == 0)    /* don't initmatrix if file is encapsulated */
     {
         strcpy(pout," initmatrix");
         plot_out(pout);
         
         if( rotp == 'y')  /* label the printout */
         {
         	strcpy(pout,"/Helvetica findfont  [12 0 0 12 0 0] makefont setfont");
         	plot_out(pout);
         	sprintf(pout," 30 770 moveto (%s %s) show ",filecurrent,now);
         }
         else
         {
         	strcpy(pout,"/Helvetica findfont  [0 -12 12 0 0 0] makefont setfont");
         	plot_out(pout);
         	sprintf(pout," 590 770 moveto (%s %s) show ",filecurrent,now);         
         
         }
         plot_out(pout);
     }

      strcpy(pout,"72 72 scale 0.35 10.46 translate -90 rotate ");
      plot_out(pout);

      strcpy(pout," .000984 .000984 scale [ ] 0 setdash");
      plot_out(pout);
      
/*  doubt we need this anymore     
      if( encap == 0)
      {
          strcpy(pout, " statusdict begin /waittimeout 900 def end ");
          plot_out(pout);
      }
*/

      strcpy(pout," /m {moveto} def /l {lineto} def /s {stroke} def /n {newpath} def ");
      plot_out(pout);

        sprintf(pout," %i setlinejoin ",psjoin);
        plot_out(pout);

/*
15000 REM
15010 REM  define fonts
15020 REM
*/
      currfont = 2;

      strcpy(font[1],"/Helvetica-Bold");
      strcpy(font[2],"/Helvetica");
      strcpy(font[3],"/Helvetica-BoldOblique");
      strcpy(font[4],"/Times-Roman");
      strcpy(font[5],"/Times-Bold");
      strcpy(font[6],"/Times-Italic");
      strcpy(font[7],"/Symbol");
      strcpy(font[8],"/Palatino-Roman");
      strcpy(font[9],"/Palatino-Bold");
/*
      REM
      REM   DEFINE SYMBOL PROCS
      REM
*/
      strcpy(pout," /square { m -45 -45 rm 90 0 rl 0 90 rl -90 0 rl closepath } def ");  plot_out(pout);
      strcpy(pout," /triangle { m 0 -33 rm 57.7 0 rl -57.7 100 rl -57.7 -100 rl closepath } def ");  plot_out(pout);
      strcpy(pout," /cone { m 0 33 rm -57.7 0 rl 57.7 -100 rl 57.7 100 rl closepath } def ");  plot_out(pout);
      strcpy(pout," /cross { m -45 -45 rm 90 90 rl -90 0 rm 90 -90 rl } def "); plot_out(pout);
      strcpy(pout," /circle { 50 sf mul 0 360 arc } def "); plot_out(pout);

      if( rotp=='y' || rotp=='Y')
      {
           strcpy(pout," /rot (Y) def ");  plot_out(pout);
      }
       else
      {
           strcpy(pout," /rot (N) def "); plot_out(pout);
      }
/*
      if( sx > sy)
      {
           t = sx / .75;
      }
      else
      {
           t = sy / .75;
      }
*/
        t = symbol_scale;

      sprintf(pout," /sf %f def /msf -1 sf mul def ",t);  plot_out(pout);

      strcpy(pout," /rm { (Y) rot eq { [ 0 sf msf 0 0 0 ] dtransform rmoveto } { [ sf 0 0 sf 0 0 ] dtransform rmoveto } ifelse } def ");  plot_out(pout);
      strcpy(pout," /rl { (Y) rot eq { [ 0 sf msf 0 0 0 ] dtransform rlineto } { [ sf 0 0 sf 0 0 ] dtransform rlineto } ifelse } def ");  plot_out(pout);

/* define font procs */

        sprintf(pout,"/fheight %f def",200.*vp); plot_out(pout);
/* drops/raises amounts define here */
        strcpy(pout,"/drop 0.25 def"); plot_out(pout);
        strcpy(pout,"/raise 0.6 def"); plot_out(pout);

/* drops/raises for angle of 0 */
        strcpy(pout,"/dropy fheight drop mul def"); plot_out(pout);
        strcpy(pout,"/dropx fheight 0.0 mul def"); plot_out(pout);
        strcpy(pout,"/mdropx dropx -1 mul def"); plot_out(pout);
        strcpy(pout,"/mdropy dropy -1 mul def"); plot_out(pout);
        strcpy(pout,"/raisey fheight raise mul def"); plot_out(pout);
        strcpy(pout,"/mraisey raisey -1 mul def"); plot_out(pout);
        strcpy(pout,"/raisex fheight 0.0 mul def"); plot_out(pout);
        strcpy(pout,"/mraisex raisex -1 mul def"); plot_out(pout);
/* size of sub/sup characters */
        strcpy(pout,"/supsub 0.8 def"); plot_out(pout);
        strcpy(pout,"/isupsub 1.0 supsub div def"); plot_out(pout);

        strcpy(pout,"/subshow { currentfont supsub scalefont setfont mdropx mdropy rmoveto "); plot_out(pout);
        strcpy(pout,"show dropx dropy rmoveto currentfont isupsub scalefont setfont} def"); plot_out(pout);

        strcpy(pout,"/supshow { currentfont supsub scalefont setfont raisex raisey rmoveto show "); plot_out(pout);
        strcpy(pout,"mraisex mraisey rmoveto currentfont isupsub scalefont setfont} def"); plot_out(pout);
}


ps_line (int n )
{
/*
14037 REM
14038 REM LINE TO X,Y FROM CURRENT POINT
14039 REM
*/
int tx,ty,ii;

      tx = xy[1]; ty = xy[2];  plot_rotate(&tx, &ty);

      sprintf(pout," n %i %i m ",tx,ty); plot_out(pout);

      for(ii = 2;ii <= n;ii++)
      {
           tx = xy[2 * ii - 1];  ty = xy[2 * ii]; plot_rotate(&tx, &ty);
           sprintf(pout,"%i %i l ",tx,ty); plot_out(pout);
      }
      strcpy(pout, " s "); plot_out(pout);
}


ps_linetype (int *t)
{
/*
      REM
      REM LINE TYPE
      REM
*/

      if(*t ==  0 )  sprintf(pout," [ ] 0 setdash 0 setlinecap ");
      if(*t ==  1 )  sprintf(pout," [ 3 %f ] 0 setdash 1 setlinecap ",patlen*49);
      if(*t ==  2 )  sprintf(pout," [ %f ] 0 setdash ",patlen*50);
      if(*t ==  3 )  sprintf(pout," [ %f %f ] 0 setdash ",patlen*75,patlen*25);
      if(*t ==  4 )  sprintf(pout," [ %f %f %f %f ] 0 setdash 0 setlinecap ",patlen*81,patlen*9,patlen*2,patlen*9);
      if(*t ==  5 )  sprintf(pout," [ %f %f %f %f ] 0 setdash 0 setlinecap ",patlen*69,patlen*10,patlen*10,patlen*10);
      if(*t >=  6 )  sprintf(pout," [ %f %f %f %f %f %f ] 0 setdash 0 setlinecap ",patlen*40,patlen*10,patlen*10,patlen*10,patlen*10,patlen*10);
      plot_out(pout);
}

ps_setpen (int t)
{
/*
14017 REM
14018 REM SELECT PEN
14019 REM
*/
if( t == 0)
{
      if( encap == 0)
      {
            strcpy(pout, "showpage"); plot_out(pout);
            
            /* don't need, wasn't being used anyways
            strcpy(pout, "statusdict begin /waittimeout 30 def end ");
            */
      }
      sprintf(pout,"%%%%DocumentFonts: %s",fontsused);
}

      if(t == 1 )  sprintf(pout," 28 setlinewidth 2 setlinecap ");
      if(t == 2 )  sprintf(pout," 12 setlinewidth 0 setlinecap ");
      if(t == 3 )  sprintf(pout," 18 setlinewidth 0 setlinecap ");
      if(t == 4 )  sprintf(pout," 6 setlinewidth 0 setlinecap ");
      if(t == 5 )  sprintf(pout," 3 setlinewidth 0 setlinecap ");
      if(t >= 6 )  sprintf(pout," 36 setlinewidth 0 setlinecap ");

      plot_out(pout);
}

ps_symbol (int x,int y,int t)
{
/*
14047 REM
14048 REM SYMBOL AT X,Y
14049 REM
*/
int tx,ty;

      tx = x; ty = y;  plot_rotate(&tx, &ty);
      strcpy(pout," currentdash pop /t2 exch def [ ] 0 setdash ");
      plot_out(pout);
      sprintf(pout," n %i %i ",tx,ty);
      if(t == 1 || t == 5 )  strcat(pout, " square ");
      if(t == 2 || t == 6 )  strcat(pout, " circle ");
      if(t == 3 || t == 7 )  strcat(pout, " triangle ");
      if(t == 4 || t == 8 )  strcat(pout, " cone ");
      if(t > 8 ) strcat(pout," cross ");

      if(t < 5 || t > 8 )
      {
             strcat(pout," s ");
      }
      else
      {
            strcat(pout," fill ");
      }
      plot_out(pout);

      strcpy(pout," t2 0 setdash "); plot_out(pout);

}

ps_escape_text(char *text)
{
/*
        add escapes to special postscript characters
*/
char temp[100];
int l,i,k;
l = strlen(text);
k=0;

for(i=0;i<l;i++)
{
        if(text[i] == '(' || text[i]== ')' || text[i] == '[' || text[i]== ']')
        {
                temp[k]='\\';
                k=k+1;
        }
        temp[k]=text[i];
        k=k+1;
}
temp[k]='\0';
strcpy(text,temp);
}

int ps_strlen(char * text)
{
int k,i,l;
/*
        for centered text need length of string without
        special characters, not exact due to small font
        in sub/sup's
*/

        l = strlen(text);
        k=0;
        for(i=0;i<l;i++)
        {
                if( text[i] != '{' && text[i]!='}' && text[i]!='^' && text[i]!='_' && text[i]!='$')
                {
                        k = k + 1;
                }
        }
        return(k);
}

ps_text (int tx,int ty,char *tt,int t)
{
/*
        puts text at tx,ty on the plot rotated by t (0,90,180,270)

        has TeX like formatting for superscripts/subscripts and greek

        ^ makes the next character a superscript
        ^{..} makes the next group of characters superscripts
        _ makes the next character a subscript
        _{..} makes the next group of characters subscripts

        $text$ uses symbol font for text (greek)

        Note for sub/sup $c$ counts as multiple characters
        so need:

        x^{$l$} to get x raised to the lambda

        also can put data point symbols in text

        use @# where # = number of the symbol to show (2-9)

*/
char temp[100],c,frag[100],test[10],cmd[10],rest[100];
int ttx,tty,i,l,f,k,setsymbol,iv;

      if(rotp == 'y' || rotp == 'Y') t = t + 90;
      if( t == 360 ) t = 0;

      if(t == 0 )  sprintf(pout,"%s findfont currentfont ne { %s findfont %f scalefont setfont } if ",font[currfont],font[currfont],200*vp);
      if(t == 90 )  sprintf(pout,"%s findfont currentfont ne { %s findfont [0 %f -%f 0 0 0] makefont setfont } if ",font[currfont],font[currfont],200*vp,200*vp);
      if(t == 180 )  sprintf(pout,"%s findfont currentfont ne { %s findfont [-%f 0 0 -%f 0 0] makefont setfont } if ",font[currfont],font[currfont],200*vp,200*vp);
      if(t == 270 )  sprintf(pout,"%s findfont currentfont ne { %s findfont [0 -%f %f 0 0 0] makefont setfont } if ",font[currfont],font[currfont],200*vp,200*vp);

      ps_fontused(currfont);

      ttx=tx;
      tty=ty;
      plot_rotate(&ttx, &tty);
      sprintf(temp, "%i %i moveto ",ttx,tty);
      strcat(pout, temp);
      plot_out(pout);

      /* have to set sub/sup offsets for text angle */

      if( t == 0 )
      {
        strcpy(pout,"/dropy fheight drop mul def"); plot_out(pout);
        strcpy(pout,"/dropx fheight 0.0 mul def"); plot_out(pout);
        strcpy(pout,"/mdropx dropx -1 mul def"); plot_out(pout);
        strcpy(pout,"/mdropy dropy -1 mul def"); plot_out(pout);
        strcpy(pout,"/raisey fheight raise mul def"); plot_out(pout);
        strcpy(pout,"/mraisey raisey -1 mul def"); plot_out(pout);
        strcpy(pout,"/raisex fheight 0.0 mul def"); plot_out(pout);
        strcpy(pout,"/mraisex raisex -1 mul def"); plot_out(pout);
      }
      if( t == 270 )
      {
        strcpy(pout,"/dropy fheight 0.0 mul def"); plot_out(pout);
        strcpy(pout,"/dropx fheight drop mul def"); plot_out(pout);
        strcpy(pout,"/mdropx dropx -1 mul def"); plot_out(pout);
        strcpy(pout,"/mdropy dropy -1 mul def"); plot_out(pout);
        strcpy(pout,"/raisey fheight 0.0 mul def"); plot_out(pout);
        strcpy(pout,"/mraisey raisey -1 mul def"); plot_out(pout);
        strcpy(pout,"/raisex fheight raise mul def"); plot_out(pout);
        strcpy(pout,"/mraisex raisex -1 mul def"); plot_out(pout);
      }
      if( t == 180 )
      {
        strcpy(pout,"/dropy fheight -1 drop mul mul def"); plot_out(pout);
        strcpy(pout,"/dropx fheight 0.0 mul def"); plot_out(pout);
        strcpy(pout,"/mdropx dropx -1 mul def"); plot_out(pout);
        strcpy(pout,"/mdropy dropy -1 mul def"); plot_out(pout);
        strcpy(pout,"/raisey fheight -1 raise mul mul def"); plot_out(pout);
        strcpy(pout,"/mraisey raisey -1 mul def"); plot_out(pout);
        strcpy(pout,"/raisex fheight 0.0 mul def"); plot_out(pout);
        strcpy(pout,"/mraisex raisex -1 mul def"); plot_out(pout);
      }
      if( t == 90 )
      {
        strcpy(pout,"/dropy fheight 0.0 mul def"); plot_out(pout);
        strcpy(pout,"/dropx fheight -1 drop mul mul def"); plot_out(pout);
        strcpy(pout,"/mdropx dropx -1 mul def"); plot_out(pout);
        strcpy(pout,"/mdropy dropy -1 mul def"); plot_out(pout);
        strcpy(pout,"/raisey fheight 0.0 mul def"); plot_out(pout);
        strcpy(pout,"/mraisey raisey -1 mul def"); plot_out(pout);
        strcpy(pout,"/raisex fheight -1 raise mul mul def"); plot_out(pout);
        strcpy(pout,"/mraisex raisex -1 mul def"); plot_out(pout);
      }

        setsymbol = 0;

        l = strlen(tt);

        strcpy(test,"$_^}@");    /* special chars to trap for */

        strcpy(rest, tt);

        ps_escape_text(rest);

        strcpy(cmd,"show");

        do
        {
                k = strcspn(rest,test); /* find location of next special character */

                if( k == 0 )    /* if first character don't need to show frag */
                {
                        if(rest[0] == '}' )    /* no action needed, strip it */
                        {
                                frag[0]=rest[0];
                                frag[1]='\0';
                                strcpy(temp,&rest[1]);
                                strcpy(rest,temp);
                        }

                }
                else
                {     /* have some characters to show with current cmd */

                        strcpy(frag,rest);
                        frag[k]='\0';  /* get left part */
                        strcpy(temp,&rest[k]); /* get right part */
                        strcpy(rest,temp);

                        sprintf(pout,"(%s) %s ",frag,cmd); plot_out(pout);
                }

                if( rest[0] == '$' ) /* change font to symbol or back */
                {
                        if(setsymbol == 0)
                        {
                                f = 7;
                                setsymbol = 1;
                        }
                        else
                        {
                                f = currfont;
                                setsymbol = 0;
                        }

      if(t == 0 )  sprintf(pout,"%s findfont currentfont ne { %s findfont %f scalefont setfont } if ",font[f],font[f],200*vp);
      if(t == 90 )  sprintf(pout,"%s findfont currentfont ne { %s findfont [0 %f -%f 0 0 0] makefont setfont } if ",font[f],font[f],200*vp,200*vp);
      if(t == 180 )  sprintf(pout,"%s findfont currentfont ne { %s findfont [-%f 0 0 -%f 0 0] makefont setfont } if ",font[f],font[f],200*vp,200*vp);
      if(t == 270 )  sprintf(pout,"%s findfont currentfont ne { %s findfont [0 -%f %f 0 0 0] makefont setfont } if ",font[f],font[f],200*vp,200*vp);

                        plot_out(pout);

                        ps_fontused(f);

                       strcpy(temp,&rest[1]);
                       strcpy(rest,temp);
                 }
                else
                {      /* don't lose the cmd if just changing fonts */
                       strcpy(cmd,"show"); /* reset command to show */
                }

                if( rest[0] == '@') /* put a symbol here */
                {
                        iv = atoi(&rest[1]); /* get symbol number */
                        iv = iv - 1;
                        strcpy(pout," currentdash pop /t2 exch def [ ] 0 setdash ");
                        plot_out(pout);

                        /* need currentpoint to draw symbol at and to restore location */
                        strcpy(pout," currentpoint raisex raisey rmoveto currentpoint n ");
                        if(iv == 1 || iv == 5 )  strcat(pout, " square ");
                        if(iv == 2 || iv == 6 )  strcat(pout, " circle ");
                        if(iv == 3 || iv == 7 )  strcat(pout, " triangle ");
                        if(iv == 4 || iv == 8 )  strcat(pout, " cone ");
                        if(iv > 8 ) strcat(pout," cross ");

                        if(iv < 5 || iv > 8 )
                        {
                                strcat(pout," s ");
                        }
                        else
                        {
                                strcat(pout," fill ");
                        }
                        plot_out(pout);

                        /* moveto gets us back to old current point */

                        strcpy(pout," t2 0 setdash moveto "); plot_out(pout);

                        rest[0]=' ';  /* leave spaces for symbol */
                        rest[1]=' ';

                        if( iv > 8)  /* means was @10 so need extra character removed */
                        {
                                rest[2]=' ';
                                strcpy(temp,&rest[1]);
                                strcpy(rest,temp);
                         }

                }

                if( rest[0] == '_')  /* subscript */
                {
                        if( rest[1] == '{' )   /* is it single character ? */
                        {
                                strcpy(cmd,"subshow");
                                strcpy(temp,&rest[2]);
                                strcpy(rest,temp);
                        }
                        else
                        {
                                c = rest[1];
                                sprintf(pout,"(%c) subshow ",c); plot_out(pout);
                                strcpy(temp,&rest[2]);
                                strcpy(rest,temp);
                        }
                }

                if( rest[0] == '^') /* superscript */
                {
                        if( rest[1] == '{' )  /* is it multi character ? */
                        {
                                strcpy(cmd,"supshow");
                                strcpy(temp,&rest[2]);
                                strcpy(rest,temp);

                        }
                        else
                        {
                                c = rest[1];
                                sprintf(pout,"(%c) supshow ",c); plot_out(pout);
                                strcpy(temp,&rest[2]);
                                strcpy(rest,temp);
                        }
                }

                l = strlen(rest); /* how much is left ? */

        }
        while ( l > 0 );  /* go till none left */

}

ps_fontused(int f)
{
/*

  stores the current font name in fontsused for encap PS
  if it is not already there.
*/
char *temp;


        temp = &font[f][0];

        if(strstr(fontsused, temp) == NULL)
        {
            strcat(fontsused," ");
            strcat(fontsused,temp);
        }

}

ps_color(int t)
{
/*
      colors used for PS printing, fully saturated to avoid dithering

*/
int r,g,b;
float fr,fg,fb;

         if(t == 0 )/* black */
         {
                 strcpy(pout," 0 setgray ");
                 plot_out(pout);
                 return(0);
         }

next_color:

         if( t == 1)
         {
                 r=0;g=0;b=255; /* blue */
         }
         if( t == 2)
         {
                 r=0;g=255;b=0;/* green */
         }
         if( t == 3)
         {
                 r=255;g=0;b=0; /* red */
         }
         if( t == 4)
         {
                 r=0;g=255;b=255;/* cyan */
         }
         if( t == 5)
         {
                 r=255;g=0;b=255;/* magenta */
         }
         if( t == 6)
         {
                 r=139;g=69;b=19;/* saddle brown */
/*                 r=255;g=255;b=0;*/ /* yellow */
         }
         if( t == 7)
         {
                 r=255;g=255;b=255;/* white */
         }

         if(t > 7){ t = t - 7; goto next_color;}

         /* postscript color range is 0-1 */

         fr=(float)r/255.;
         fb=(float)b/255.;
         fg=(float)g/255.;

        sprintf(pout," %f %f %f setrgbcolor ",fr,fg,fb);
        plot_out(pout);

}

